glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DataInputStream Class Reference
Stream Classes

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations). More...

`#include <giomm/datainputstream.h>`

Inheritance diagram for Gio::DataInputStream:
[legend]

## Public Member Functions
| DataInputStream (DataInputStream&& src) noexcept
DataInputStream& | operator= (DataInputStream&& src) noexcept
| ~DataInputStream () noexcept override
GDataInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GDataInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GDataInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_byte_order (DataStreamByteOrder order)
| This function sets the byte order for the given stream. More...
DataStreamByteOrder | get_byte_order () const
| Gets the byte order for the data input stream. More...
void | set_newline_type (DataStreamNewlineType type)
| Sets the newline type for the stream. More...
DataStreamNewlineType | get_newline_type () const
| Gets the current newline type for the stream. More...
guchar | read_byte (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 8-bit/1-byte value from stream. More...
guchar | read_byte ()
| A read_byte() convenience overload. More...
gint16 | read_int16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 16-bit/2-byte value from stream. More...
gint16 | read_int16 ()
| A read_int16() convenience overload. More...
guint16 | read_uint16 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 16-bit/2-byte value from stream. More...
guint16 | read_uint16 ()
| A read_uint16() convenience overload. More...
gint32 | read_int32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a signed 32-bit/4-byte value from stream. More...
gint32 | read_int32 ()
| A read_int32() convenience overload. More...
guint32 | read_uint32 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 32-bit/4-byte value from stream. More...
guint32 | read_uint32 ()
| A read_uint32() convenience overload. More...
gint64 | read_int64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads a 64-bit/8-byte value from stream. More...
gint64 | read_int64 ()
| A read_int64() convenience overload. More...
guint64 | read_uint64 (const Glib::RefPtr< Cancellable >& cancellable)
| Reads an unsigned 64-bit/8-byte value from stream. More...
guint64 | read_uint64 ()
| A read_uint64() convenience overload. More...
bool | read_line (std::string& line, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a line from the data input stream. More...
bool | read_line (std::string& line)
| A non-cancellable version of read_line(). More...
void | read_line_utf8 (std::string& line, const Glib::RefPtr< Cancellable >& cancellable, gsize& length)
| Reads a UTF-8 encoded line from the data input stream. More...
void | read_line_utf8 (std::string& line, const Glib::RefPtr< Cancellable >& cancellable)
| A read_line_utf8() convenience overload. More...
void | read_line_utf8 (std::string& line, gsize& length)
| A read_line_utf8() convenience overload. More...
void | read_line_utf8 (std::string& line)
| A read_line_utf8() convenience overload. More...
void | read_line_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_line(). More...
bool | read_line_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_line_async(). More...
void | read_line_finish_utf8 (const Glib::RefPtr< AsyncResult >& result, std::string& data, gsize& length)
| Finish an asynchronous call started by read_line_async(). More...
void | read_line_finish_utf8 (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| A read_line_finish_utf8() convenience overload. More...
bool | read_until (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters. More...
bool | read_until (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_until(). More...
void | read_until_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_until(). More...
bool | read_until_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_until_async(). More...
bool | read_upto (std::string& data, const std::string& stop_chars, const Glib::RefPtr< Cancellable >& cancellable)
| Reads a string from the data input stream, up to the first occurrence of any of the stop characters. More...
bool | read_upto (std::string& data, const std::string& stop_chars)
| A non-cancellable version of read_upto(). More...
void | read_upto_async (const std::string& stop_chars, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| The asynchronous version of read_upto(). More...
bool | read_upto_finish (const Glib::RefPtr< AsyncResult >& result, std::string& data)
| Finish an asynchronous call started by read_upto_async(). More...
Glib::PropertyProxy< DataStreamByteOrder > | property_byte_order ()
| The byte order. More...
Glib::PropertyProxy_ReadOnly< DataStreamByteOrder > | property_byte_order () const
| The byte order. More...
Glib::PropertyProxy< DataStreamNewlineType > | property_newline_type ()
| The accepted types of line ending. More...
Glib::PropertyProxy_ReadOnly< DataStreamNewlineType > | property_newline_type () const
| The accepted types of line ending. More...
Public Member Functions inherited from Gio::BufferedInputStream
| BufferedInputStream (BufferedInputStream&& src) noexcept
BufferedInputStream& | operator= (BufferedInputStream&& src) noexcept
| ~BufferedInputStream () noexcept override
GBufferedInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GBufferedInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GBufferedInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
gsize | get_buffer_size () const
| Gets the size of the input buffer. More...
void | set_buffer_size (gsize size)
| Sets the size of the internal buffer of stream to size, or to the size of the contents of the buffer. More...
gsize | get_available () const
| Gets the size of the available data within the stream. More...
gsize | peek (void* buffer, gsize offset, gsize count) const
| Peeks in the buffer, copying data of size count into buffer, offset offset bytes. More...
const void* | peek_buffer (gsize&count) const
| Returns the buffer with the currently available bytes. More...
gssize | fill (gssize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer. More...
gssize | fill (gssize count)
| A fill() convenience overload. More...
void | fill_async (const SlotAsyncReady& slot, gssize count, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Reads data into the stream's buffer asynchronously, up to count size. More...
void | fill_async (const SlotAsyncReady& slot, gssize count, int io_priority=Glib::PRIORITY_DEFAULT)
| Reads data into the stream's buffer asynchronously, up to count size. More...
gssize | fill_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous read. More...
int | read_byte (const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read a single byte from the stream or the buffer. More...
int | read_byte ()
| A read_byte() convenience overload. More...
Glib::PropertyProxy< guint > | property_buffer_size ()
| The size of the backend buffer. More...
Glib::PropertyProxy_ReadOnly< guint > | property_buffer_size () const
| The size of the backend buffer. More...
Public Member Functions inherited from Gio::FilterInputStream
| FilterInputStream (FilterInputStream&& src) noexcept
FilterInputStream& | operator= (FilterInputStream&& src) noexcept
| ~FilterInputStream () noexcept override
GFilterInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GFilterInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GFilterInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< InputStream > | get_base_stream ()
| Gets the base stream for the filter stream. More...
Glib::RefPtr< const InputStream > | get_base_stream () const
| Gets the base stream for the filter stream. More...
bool | get_close_base_stream () const
| Returns whether the base stream will be closed when stream is closed. More...
void | set_close_base_stream (bool close_base=true)
| Sets whether the base stream will be closed when stream is closed. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< InputStream > > | property_base_stream () const
| The underlying base stream on which the io ops will be done. More...
Glib::PropertyProxy< bool > | property_close_base_stream ()
| If the base stream should be closed when the filter stream is closed. More...
Glib::PropertyProxy_ReadOnly< bool > | property_close_base_stream () const
| If the base stream should be closed when the filter stream is closed. More...
Public Member Functions inherited from Gio::InputStream
| InputStream (InputStream&& src) noexcept
InputStream& | operator= (InputStream&& src) noexcept
| ~InputStream () noexcept override
GInputStream* | gobj ()
| Provides access to the underlying C GObject. More...
const GInputStream* | gobj () const
| Provides access to the underlying C GObject. More...
GInputStream* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
gssize | read (void* buffer, gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
gssize | read (void* buffer, gsize count)
| A read() convenience overload. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to read count bytes from the stream into the buffer starting at buffer. More...
bool | read_all (void* buffer, gsize count, gsize& bytes_read)
| A read_all() convenience overload. More...
Glib::RefPtr< Glib::Bytes > | read_bytes (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Like g_input_stream_read(), this tries to read count bytes from the stream in a blocking fashion. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
void | read_bytes_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into a new Glib::Bytes. More...
Glib::RefPtr< Glib::Bytes > | read_bytes_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read-into-Bytes operation. More...
gssize | skip (gsize count, const Glib::RefPtr< Cancellable >& cancellable)
| Tries to skip count bytes from the stream. More...
gssize | skip (gsize count)
| A skip() convenience overload. More...
bool | close (const Glib::RefPtr< Cancellable >& cancellable)
| Closes the stream, releasing resources related to it. More...
bool | close ()
| A close() convenience overload. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
gssize | read_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an asynchronous stream read operation. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
void | read_all_async (void* buffer, gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous read of count bytes from the stream into the buffer starting at buffer. More...
bool | read_all_finish (const Glib::RefPtr< AsyncResult >& result, gsize& bytes_read)
| Finishes an asynchronous stream read operation started with g_input_stream_read_all_async(). More...
void | skip_async (gsize count, const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
void | skip_async (gsize count, const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Request an asynchronous skip of count bytes from the stream into the buffer starting at buffer. More...
gssize | skip_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes a stream skip operation. More...
void | close_async (const SlotAsyncReady& slot, const Glib::RefPtr< Cancellable >& cancellable, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
void | close_async (const SlotAsyncReady& slot, int io_priority=Glib::PRIORITY_DEFAULT)
| Requests an asynchronous closes of the stream, releasing resources related to it. More...
gboolean | close_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes closing a stream asynchronously, started from g_input_stream_close_async(). More...
bool | is_closed () const
| Checks if an input stream is closed. More...
bool | has_pending () const
| Checks if an input stream has pending actions. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< DataInputStream > | create (const Glib::RefPtr< InputStream >& base_stream)
Static Public Member Functions inherited from Gio::BufferedInputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< BufferedInputStream > | create (const Glib::RefPtr< InputStream >& base_stream)
| Creates a new InputStream from the given base_stream, with a buffer set to the default size (4 kilobytes). More...
static Glib::RefPtr< BufferedInputStream > | create_sized (const Glib::RefPtr< InputStream >& base_stream, gsize buffer_size)
| Creates a new InputStream from the given base_stream, with a buffer set to size. More...
Static Public Member Functions inherited from Gio::FilterInputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gio::InputStream
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| DataInputStream (const Glib::RefPtr< InputStream >& base_stream)
Protected Member Functions inherited from Gio::BufferedInputStream
| BufferedInputStream (const Glib::RefPtr< InputStream >& base_stream)
| BufferedInputStream (const Glib::RefPtr< InputStream >& base_stream, gsize buffer_size)
Protected Member Functions inherited from Gio::FilterInputStream
| FilterInputStream (const Glib::RefPtr< InputStream >& base_stream)
Protected Member Functions inherited from Gio::InputStream
| InputStream ()
bool | set_pending ()
| Sets stream to have actions pending. More...
void | clear_pending ()
| Clears the pending flag on stream. More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::DataInputStream > | wrap (GDataInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::BufferedInputStream
Glib::RefPtr< Gio::BufferedInputStream > | wrap (GBufferedInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::FilterInputStream
Glib::RefPtr< Gio::FilterInputStream > | wrap (GFilterInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::InputStream
Glib::RefPtr< Gio::InputStream > | wrap (GInputStream* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

An implementation of BufferedInputStream that allows for high-level data manipulation of arbitrary data (including binary operations).

Since glibmm 2.16:

## Constructor & Destructor Documentation

## ◆ DataInputStream() [1/2]

Gio::DataInputStream::DataInputStream | ( | DataInputStream&& | src | ) |
| noexcept

## ◆ ~DataInputStream()

Gio::DataInputStream::~DataInputStream | ( |  | ) |
| override noexcept

## ◆ DataInputStream() [2/2]

Gio::DataInputStream::DataInputStream | ( | const Glib::RefPtr< InputStream >& | base_stream | ) |
| explicit protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<DataInputStream> Gio::DataInputStream::create | ( | const Glib::RefPtr< InputStream >& | base_stream | ) |
| static

## ◆ get_byte_order()

DataStreamByteOrder Gio::DataInputStream::get_byte_order | ( |  | ) | const

Gets the byte order for the data input stream.

Returns
  The stream's current DataStreamByteOrder.

## ◆ get_newline_type()

DataStreamNewlineType Gio::DataInputStream::get_newline_type | ( |  | ) | const

Gets the current newline type for the stream.

Returns
  DataStreamNewlineType for the given stream.

## ◆ get_type()

static GType Gio::DataInputStream::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GDataInputStream* Gio::DataInputStream::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GDataInputStream* Gio::DataInputStream::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

DataInputStream& Gio::DataInputStream::operator= | ( | DataInputStream&& | src | ) |
| noexcept

## ◆ property_byte_order() [1/2]

Glib::PropertyProxy< DataStreamByteOrder > Gio::DataInputStream::property_byte_order | ( |  | ) |

The byte order.

Default value: DATA_STREAM_BYTE_ORDER_BIG_ENDIAN

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_byte_order() [2/2]

Glib::PropertyProxy_ReadOnly< DataStreamByteOrder > Gio::DataInputStream::property_byte_order | ( |  | ) | const

The byte order.

Default value: DATA_STREAM_BYTE_ORDER_BIG_ENDIAN

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_newline_type() [1/2]

Glib::PropertyProxy< DataStreamNewlineType > Gio::DataInputStream::property_newline_type | ( |  | ) |

The accepted types of line ending.

Default value: DATA_STREAM_NEWLINE_TYPE_LF

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_newline_type() [2/2]

Glib::PropertyProxy_ReadOnly< DataStreamNewlineType > Gio::DataInputStream::property_newline_type | ( |  | ) | const

The accepted types of line ending.

Default value: DATA_STREAM_NEWLINE_TYPE_LF

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ read_byte() [1/2]

guchar Gio::DataInputStream::read_byte | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 8-bit/1-byte value from stream.

Parameters

  cancellable | Optional Cancellable object, `nullptr` to ignore.

Returns
  An unsigned 8-bit/1-byte value read from the stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_byte() [2/2]

guchar Gio::DataInputStream::read_byte | ( |  | ) |

A read_byte() convenience overload.

## ◆ read_int16() [1/2]

gint16 Gio::DataInputStream::read_int16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters

  cancellable | Optional Cancellable object, `nullptr` to ignore.

Returns
  A signed 16-bit/2-byte value read from stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_int16() [2/2]

gint16 Gio::DataInputStream::read_int16 | ( |  | ) |

A read_int16() convenience overload.

## ◆ read_int32() [1/2]

gint32 Gio::DataInputStream::read_int32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a signed 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters

  cancellable | Cancellable object.

Returns
  A signed 32-bit/4-byte value read from the stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_int32() [2/2]

gint32 Gio::DataInputStream::read_int32 | ( |  | ) |

A read_int32() convenience overload.

## ◆ read_int64() [1/2]

gint64 Gio::DataInputStream::read_int64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads a 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters

  cancellable | Cancellable object.

Returns
  A signed 64-bit/8-byte value read from stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_int64() [2/2]

gint64 Gio::DataInputStream::read_int64 | ( |  | ) |

A read_int64() convenience overload.

## ◆ read_line() [1/2]

bool Gio::DataInputStream::read_line | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a line from the data input stream.

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error with CANCELLED will be thrown.

Parameters

  [out] | line | A string to fill with the read data (without the newlines).
  | cancellable | A cancellable object.

Returns
  true if the read succeeded without error.

## ◆ read_line() [2/2]

bool Gio::DataInputStream::read_line | ( | std::string & | line | ) |

A non-cancellable version of read_line().

Parameters

  [out] | line | A string to fill with the read data (without the newlines).

Returns
  true if the read succeeded without error.

## ◆ read_line_async()

void Gio::DataInputStream::read_line_async | ( | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_line().

It is an error to have two outstanding calls to this function.

Parameters

  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

## ◆ read_line_finish()

bool Gio::DataInputStream::read_line_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_line_async().

Parameters

  | result | The AsyncResult that was provided to the callback slot.
  [out] | data | A string to fill with the read data.

Returns
  true if the read succeeded without error.

## ◆ read_line_finish_utf8() [1/2]

void Gio::DataInputStream::read_line_finish_utf8 | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data,
|  | gsize & | length
| ) |  |

Finish an asynchronous call started by read_line_async().

Since glibmm 2.30:

Parameters

  | result | The AsyncResult that was provided to the callback.
  [out] | data | A UTF-8 string with the line that was read in (without the newlines). Supply length to get the length of the read line. On an error, line is set to an empty string and an exception is thrown. For UTF-8 conversion errors, a Glib::ConvertError is thrown. If there's no content to read, line will still be set to an empty string, but no exception will be thrown.
  [out] | length | An optional gsize to get the length of the data read in.

## ◆ read_line_finish_utf8() [2/2]

void Gio::DataInputStream::read_line_finish_utf8 | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

A read_line_finish_utf8() convenience overload.

## ◆ read_line_utf8() [1/4]

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | gsize & | length
| ) |  |

Reads a UTF-8 encoded line from the data input stream.

If cancellable is supplied and not equal to Glib::RefPtr<Cancellable>(), then the operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, Gio::Error with code() == Gio::Error::CANCELLED will be thrown.

Since glibmm 2.30:

Parameters

  [out] | line | A UTF-8 string with the line that was read in (without the newlines). Supply length to get the length of the read line. On an error, line is set to an empty string and an exception is thrown. For UTF-8 conversion errors, a Glib::ConvertError is thrown. If there's no content to read, line will still be set to an empty string, but no exception will be thrown.
  | cancellable | Optional Cancellable object.
  [out] | length | An optional gsize to get the length of the data read in.

## ◆ read_line_utf8() [2/4]

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

A read_line_utf8() convenience overload.

## ◆ read_line_utf8() [3/4]

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line,
|  | gsize & | length
| ) |  |

A read_line_utf8() convenience overload.

## ◆ read_line_utf8() [4/4]

void Gio::DataInputStream::read_line_utf8 | ( | std::string & | line | ) |

A read_line_utf8() convenience overload.

## ◆ read_uint16() [1/2]

guint16 Gio::DataInputStream::read_uint16 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 16-bit/2-byte value from stream.

In order to get the correct byte order for this read operation, see g_data_input_stream_get_byte_order() and g_data_input_stream_set_byte_order().

Parameters

  cancellable | Optional Cancellable object, `nullptr` to ignore.

Returns
  An unsigned 16-bit/2-byte value read from the stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_uint16() [2/2]

guint16 Gio::DataInputStream::read_uint16 | ( |  | ) |

A read_uint16() convenience overload.

## ◆ read_uint32() [1/2]

guint32 Gio::DataInputStream::read_uint32 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 32-bit/4-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order() and Glib::data_stream_set_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters

  cancellable | Cancellable object.

Returns
  An unsigned 32-bit/4-byte value read from the stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_uint32() [2/2]

guint32 Gio::DataInputStream::read_uint32 | ( |  | ) |

A read_uint32() convenience overload.

## ◆ read_uint64() [1/2]

guint64 Gio::DataInputStream::read_uint64 | ( | const Glib::RefPtr< Cancellable >& | cancellable | ) |

Reads an unsigned 64-bit/8-byte value from stream.

In order to get the correct byte order for this read operation, see Glib::data_stream_get_byte_order().

The operation can be cancelled by triggering the cancellable object from another thread. If the operation was cancelled, a Gio::Error will be thrown with CANCELLED.

Parameters

  cancellable | Cancellable object.

Returns
  An unsigned 64-bit/8-byte read from stream or %0 if an error occurred.

Exceptions

  Glib::Error |

## ◆ read_uint64() [2/2]

guint64 Gio::DataInputStream::read_uint64 | ( |  | ) |

A read_uint64() convenience overload.

## ◆ read_until() [1/2]

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Use read_upto() instead, but note that that method does not consume the stop character.

Parameters

  [out] | data | A string to fill with the read data.
  | stop_chars | Characters to terminate the read.
  | cancellable | A cancellable object.

Returns
  true if the read succeeded without error.

Deprecated:
  Use read_upto() instead, which has more consistent behaviour regarding the stop character.

## ◆ read_until() [2/2]

bool Gio::DataInputStream::read_until | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_until().

Note that, in contrast to read_until_async(), this function consumes the stop character that it finds.

Don't use this function in new code. Its functionality is inconsistent with read_until_async(). Use read_upto() instead, but note that that method does not consume the stop character.

Parameters

  [out] | data | A string to fill with the read data.
  | stop_chars | Characters to terminate the read.

Returns
  true if the read succeeded without error.

Deprecated:
  Use read_upto() instead, which has more consistent behaviour regarding the stop character.

## ◆ read_until_async()

void Gio::DataInputStream::read_until_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_until().

It is an error to have two outstanding calls to this function.

Note that, in contrast to read_until(), this function does not consume the stop character that it finds. You must read it for yourself.

Don't use this function in new code. Its functionality is inconsistent with read_until(). Use read_upto_async() instead.

Parameters

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

Deprecated:
  Use read_upto_async() instead, which has more consistent behaviour regarding the stop character.

## ◆ read_until_finish()

bool Gio::DataInputStream::read_until_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_until_async().

Parameters

  | result | The AsyncResult that was provided to the callback slot.
  [out] | data | A string to fill with the read data.

Returns
  true if the read succeeded without error.

Deprecated:
  Use read_upto_finish() instead, which has more consistent behaviour regarding the stop character.

## ◆ read_upto() [1/2]

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars,
|  | const Glib::RefPtr< Cancellable >& | cancellable
| ) |  |

Reads a string from the data input stream, up to the first occurrence of any of the stop characters.

In contrast to read_until(), this method does not consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters

  [out] | data | A string to fill with the read data.
  | stop_chars | Characters to terminate the read.
  | cancellable | A cancellable object.

Returns
  true if the read succeeded without error.

## ◆ read_upto() [2/2]

bool Gio::DataInputStream::read_upto | ( | std::string & | data,
|  | const std::string & | stop_chars
| ) |  |

A non-cancellable version of read_upto().

Parameters

  [out] | data | A string to fill with the read data.
  | stop_chars | Characters to terminate the read.

Returns
  true if the read succeeded without error.

## ◆ read_upto_async()

void Gio::DataInputStream::read_upto_async | ( | const std::string & | stop_chars,
|  | const SlotAsyncReady& | slot,
|  | const Glib::RefPtr< Cancellable >& | cancellable,
|  | int | io_priority = `Glib::PRIORITY_DEFAULT`
| ) |  |

The asynchronous version of read_upto().

It is an error to have two outstanding calls to this function.

In contrast to read_until(), this method does not consume the stop character. You have to use read_byte() to get it before calling read_upto() again.

Parameters

  stop_chars | Characters to terminate the read.
  slot | The slot to call when the request is satisfied.
  cancellable | A cancellable object.
  io_priority | The I/O priority of the request.

## ◆ read_upto_finish()

bool Gio::DataInputStream::read_upto_finish | ( | const Glib::RefPtr< AsyncResult >& | result,
|  | std::string & | data
| ) |  |

Finish an asynchronous call started by read_upto_async().

Note that this function does not consume the stop character. You have to use read_byte() to get it before calling read_upto_async() again.

Parameters

  | result | The AsyncResult that was provided to the callback slot.
  [out] | data | A string to fill with the read data.

Returns
  true if the read succeeded without error.

## ◆ set_byte_order()

void Gio::DataInputStream::set_byte_order | ( | DataStreamByteOrder | order | ) |

This function sets the byte order for the given stream.

All subsequent reads from the stream will be read in the given order.

Parameters

  order | A DataStreamByteOrder to set.

## ◆ set_newline_type()

void Gio::DataInputStream::set_newline_type | ( | DataStreamNewlineType | type | ) |

Sets the newline type for the stream.

Note that using G_DATA_STREAM_NEWLINE_TYPE_ANY is slightly unsafe. If a read chunk ends in "CR" we must read an additional byte to know if this is "CR" or "CR LF", and this might block if there is no more data available.

Parameters

  type | The type of new line return as DataStreamNewlineType.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::DataInputStream > wrap | ( | GDataInputStream * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.